#property copyright "*"
#property link      "*"

#define IND "iSCH_TimeAndRange_v2"

/*
   
      iSCH_HLChanelBreak.      
   experts/indicators.
   
      .   ""    
   
        experts.     .
   
   * * *

     :
   
   TimeFrame -  . 0 -      ,   : 1,5,15,30,60,240

   ===  ===

   StartLots -   
   Lots_K -   
   MaxCount -   
   MaxCountVariant -       : 1 -   , 2 -   
   Slippage -  
   StopLossType -  : 1 -  StopLoss, 2 -    
   StopLoss - 
   TakeProfitType -  : 1 -  TakeProfit, 2 - TP_K   
   TakeProfit - 
   TP_K -      TakeProfitType=2
   Magic_N - .             .

   ===  ===

   HLPeriod -    
   HLShift -    
   WidthPoints -    Variant=1
   AddPoints -      Variant=2,  AddPoints   
   Variant -  : 1 -      (  WidthPoints), 2 -  

   ===  ===

   Auto5Digits -         10    5-  
   MWMode -      ( StopLoss  TakeProfit)   
*/

/*

            StopLossType    2.
       ,   TakeProfitType   2,   TP_K - 1.
   
    :

   ===     ===

   DE_ON -      
   DEHour -  
   DEMinute -  
   DE_GoOn -            

*/

extern   int         TimeFrame               =  0;       //  . 0 -      ,   : 1,5,15,30,60,240
extern   string      e0                      =  "===  ===";
extern   double      StartLots               =  0.1;     //   
extern   double      Lots_K                  =  2;       //   
extern   int         MaxCount                =  10;      //   
extern   int         MaxCountVariant         =  1;       //       : 1 -   , 2 -   
extern   int         Slippage                =  3;       //  
extern   int         StopLossType            =  2;       //  : 1 -  StopLoss, 2 -    
extern   int         StopLoss                =  50;      // 
extern   int         TakeProfitType          =  2;       //  : 1 -  TakeProfit, 2 - TP_K   
extern   int         TakeProfit              =  50;      // 
extern   double      TP_K                    =  1;       //      TakeProfitType=2
extern   int         Magic_N                 =  347;     // .             .
extern   string      e1                      =  "===  ===";

extern int SHours     =  0; //     
extern int SMinutes   =  0; //    
extern int EHours     =  9; //     
extern int EMinutes   =  0; //    

extern   int         Shift                   =  0;       //      ,      0.
extern   string      s7                      =  "===     ===";  
extern   bool        DE_ON                   =  true;    //      
extern   int         DEHour                  =  23;      //  
extern   int         DEMinute                =  30;      //  
extern   bool        DE_GoOn                 =  true;    //            
extern   string      e2                      =  "===  ===";
extern   bool        Auto5Digits             =  true;    //         10    5-  
extern   bool        MWMode                  =  true;    //      ( StopLoss  TakeProfit)   

/*
       iSCH_TimeAndRange.
    iSCH_TimeAndRange          
    .
   
       "":

   ===  ===

   Hours -     
   Minutes -    
   Shift -      ,      0.
   
   
*/


int LastBuyTime,LastSellTime;
double bv,sv;
int LastTime;
string gvp;
int MarketTicket;
double Lots;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init(){
   
   if(TimeFrame==0)TimeFrame=Period();
   

   if(Auto5Digits){
      if(Digits==5 || Digits==3){
         Slippage*=10;
         StopLoss*=10;
         TakeProfit*=10;
      }
   }

   gvp=WindowExpertName()+"_"+Symbol()+"_"+Magic_N+"_";
   if(IsTesting())gvp=gvp+"t_";
   if(IsDemo())gvp=gvp+"d_";
   
   if(IsTesting()){
      for(int i=GlobalVariablesTotal()-1;i>=0;i--){
         if(StringFind(GlobalVariableName(i),gvp,0)==0){
            GlobalVariableDel(GlobalVariableName(i));
         }
      }
   }
   LastTime=0;


   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   if(IsTesting()){
      for(int i=GlobalVariablesTotal()-1;i>=0;i--){
         if(StringFind(GlobalVariableName(i),gvp,0)==0){
            GlobalVariableDel(GlobalVariableName(i));
         }
      }
   }   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+


int start(){

   if(!IsTesting()){
      if(!fDataUpdateCmnt(Symbol(),TimeFrame,3))return(0);
   }

   if(DE_ON){
      if(TimeCurrent()%86400>=DEHour*3600+DEMinute*60){
         Comment(GetTickCount());
         fOrderCloseMarket2();
         fOrderDeleteStop();
         return(0);            
      }
   }

   if(LastTime==0){
      LastTime=iTime(NULL,TimeFrame,0);
      return(0);
   }

   static bool ft=false;
   
      if(!ft){
            for(int i=0;i<OrdersTotal();i++){
               if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
                  if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic_N){
                     if(OrderType()==OP_BUY)LastBuyTime=MathMax(LastBuyTime,OrderOpenTime());
                     if(OrderType()==OP_SELL)LastSellTime=MathMax(LastSellTime,OrderOpenTime());                    
                  }
               }
               else{
                  return(0);
               }
            }   
    
            for(i=0;i<HistoryTotal();i++){
               if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)){
                  if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic_N){
                     if(OrderType()==OP_BUY)LastBuyTime=MathMax(LastBuyTime,OrderOpenTime());
                     if(OrderType()==OP_SELL)LastSellTime=MathMax(LastSellTime,OrderOpenTime());                    
                  }
               }
               else{
                  return(0);
               }
            }  
            
            if(LastBuyTime>LastSellTime)LastSellTime=0; 
            if(LastSellTime>LastBuyTime)LastBuyTime=0;
            
            if(TimeFrame==0)TimeFrame=Period();

            LastBuyTime=TimeFrame*60*MathFloor(LastBuyTime/(TimeFrame*60));
            LastSellTime=TimeFrame*60*MathFloor(LastSellTime/(TimeFrame*60));
            
         ft=true;
      }

   int BuyCount,SellCount,MarketTotal,BuyStopCount,SellStopCount,StopCount,Total;
   if(!fOrdersCountMarketAndStop(BuyCount,SellCount,MarketTotal,BuyStopCount,SellStopCount,StopCount,Total))return(0);
 
   bv=iCustom(NULL,TimeFrame,IND,SHours,SMinutes,EHours,EMinutes,0,0);
   sv=iCustom(NULL,TimeFrame,IND,SHours,SMinutes,EHours,EMinutes,1,0);
   
    
   bool bs=0;
   bool ss=0;
   if(bv!=0)bs=1;
   if(sv!=0)ss=1;
   static int pbs=-1;
   static int pss=-1;
   if(pbs==-1)pbs=bs;
   if(pss==-1)pss=ss;
   bool BuySignal=false;
   bool SellSignal=false;
   
      if(bs==1 && pbs==0){
         BuySignal=true;
      }
      if(ss==1 && pss==0){
         SellSignal=true;
      }
      
      if(BuySignal || SellSignal){
         if(Total==0){
            if(BuySignal && !SellSignal){
               if(LastBuyTime!=iTime(NULL,TimeFrame,0)){
                  Lots=StartLots;
                  string com="=1=";
                     if(DE_GoOn){
                        if(GlobalVariableCheck(gvp+"li") && GlobalVariableCheck(gvp+"ll")){
                           Lots=GlobalVariableGet(gvp+"ll");
                           com="="+GlobalVariableGet(gvp+"li")+"=";
                        } 
                     }
                     if(fOrderOpenBuy(com)>0){
                        GlobalVariableDel(gvp+"ll");
                        GlobalVariableDel(gvp+"li");
                     }
                  return(0);
               }  
            }
            if(SellSignal && !BuySignal){
               if(LastSellTime!=iTime(NULL,TimeFrame,0)){
                  Lots=StartLots;
                  com="=1=";
                     if(DE_GoOn){
                        if(GlobalVariableCheck(gvp+"li") && GlobalVariableCheck(gvp+"ll")){
                           Lots=GlobalVariableGet(gvp+"ll");
                           com="="+GlobalVariableGet(gvp+"li")+"=";
                        } 
                     }                  
                     if(fOrderOpenSell(com)>0){
                        GlobalVariableDel(gvp+"ll");
                        GlobalVariableDel(gvp+"li");                     
                     }
                  return(0);  
               }
            }
         }
      }            

   pbs=bs;
   pss=ss;

      if(MWMode){
         MW_SLTP();
      }

      if(StopCount>0){
         if(MarketTotal==0){
            fOrderDeleteStop();
            return(0);
         }
      }
      
      if(StopCount==0){
         if(MarketTotal>0){
            if(OrderSelect(MarketTicket,SELECT_BY_TICKET)){
               int Index;
                  if(ND(OrderStopLoss())!=0){
                     switch(OrderType()){
                        case OP_BUY:
                           Lots=0;
                           fOrderSelectedCommentGetIndex_1("=",Index);
                              if(Index<MaxCount){
                                 Lots=StartLots*MathPow(Lots_K,Index);
                                 Lots=fLotsNormalize(Lots);
                              }
                              else{
                                 if(MaxCountVariant==1){
                                    Lots=StartLots*MathPow(Lots_K,MaxCount-1);
                                    Lots=fLotsNormalize(Lots);
                                 }
                              }
                              if(Lots>0){
                                 double tpts=ND(OrderStopLoss()-(OrderTakeProfit()-OrderOpenPrice()));
                                 fOrderSetSellStop(ND(OrderStopLoss()),ND(OrderOpenPrice()),tpts,0,"="+(Index+1)+"=");
                              }
                        break;
                        case OP_SELL:
                           fOrderSelectedCommentGetIndex_1("=",Index);
                           Lots=0;
                           fOrderSelectedCommentGetIndex_1("=",Index);
                              if(Index<MaxCount){
                                 Lots=StartLots*MathPow(Lots_K,Index);
                                 Lots=fLotsNormalize(Lots);
                              }
                              else{
                                 if(MaxCountVariant==1){
                                    Lots=StartLots*MathPow(Lots_K,MaxCount-1);
                                    Lots=fLotsNormalize(Lots);
                                 }
                              }
                              if(Lots>0){
                                 tpts=ND(OrderStopLoss()+OrderOpenPrice()-OrderTakeProfit());
                                 fOrderSetBuyStop(ND(OrderStopLoss()),ND(OrderOpenPrice()),tpts,0,"="+(Index+1)+"=");
                              }                        
                        break;
                     }
                  }
            }
         }
      }

   return(0);
  }
//+------------------------------------------------------------------+

int fOrderCloseMarket2(bool aCloseBuy=true,bool aCloseSell=true){
   int tErr=0;
      for(int i=OrdersTotal()-1;i>=0;i--){
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
            if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic_N){
               if(OrderType()==OP_BUY && aCloseBuy){
                  RefreshRates();
                     if(!IsTradeContextBusy()){
                        
                        if(!OrderClose(OrderTicket(),OrderLots(),ND(Bid),MarketInfo(Symbol(),MODE_SPREAD)*3,CLR_NONE)){
                           int tCheck=GetLastError();
                           Print("Error close BUY "+OrderTicket()+" "+fMyErDesc(tCheck)); 
                           tErr=-1;
                        }
                        else{
                           int ind=fIndex(OrderComment(),"=");
                              if(ind>GlobalVariableGet(gvp+"li")){
                                 GlobalVariableSet(gvp+"li",ind);
                                 GlobalVariableSet(gvp+"ll",OrderLots());
                              }
                        }
                     }
                     else{
                        static int lt1=0;
                           if(lt1!=iTime(NULL,TimeFrame,0)){
                              lt1=iTime(NULL,TimeFrame,0);
                              Print("Need close BUY "+OrderTicket()+". Trade Context Busy");
                           }            
                        return(-2);
                     }   
               }
               if(OrderType()==OP_SELL && aCloseSell){
                  RefreshRates();
                     if(!IsTradeContextBusy()){                        
                        if(!OrderClose(OrderTicket(),OrderLots(),ND(Ask),MarketInfo(Symbol(),MODE_SPREAD)*3,CLR_NONE)){
                           tCheck=GetLastError();
                           Print("Error close SELL "+OrderTicket()+" "+fMyErDesc(tCheck)); 
                           tErr=-1;
                        }  
                        else{
                           ind=fIndex(OrderComment(),"=");
                              if(ind>GlobalVariableGet(gvp+"li")){
                                 GlobalVariableSet(gvp+"li",ind);
                                 GlobalVariableSet(gvp+"ll",OrderLots());
                              }
                        }                        
                     }
                     else{
                        static int lt2=0;
                           if(lt2!=iTime(NULL,TimeFrame,0)){
                              lt2=iTime(NULL,TimeFrame,0);
                              Print("Need close SELL "+OrderTicket()+". Trade Context Busy");
                           }            
                        return(-2);
                     }          
               }
            }
         }
         else{
            return(-3);
         }
      }
   return(tErr);
}  

bool fIndex(string aComment,string aDelimiterChar){
   int FirstS=StringFind(aComment,aDelimiterChar,0);
   int SecondS=StringFind(aComment,aDelimiterChar,1);
   return(StrToInteger(StringSubstr(aComment,1,SecondS-FirstS-1)));
}

int fOrderSetBuyStop(double aOpenPrice,double aStopLoss,double aTakeProfit,datetime aExpiration,string aComment){
   RefreshRates();   
   double oppr=ND(aOpenPrice);
   double msl=ND(Ask+Point*MarketInfo(Symbol(),MODE_STOPLEVEL));
      if(oppr>=msl){
         double lts=fGetLotsSimple(OP_BUY);
            if(lts>0){
               if(!IsTradeContextBusy()){
                  double slts=ND(oppr-Point*StopLoss);
                  if(StopLoss==0)slts=0;
                  double tpts=ND(oppr+Point*TakeProfit);
                  if(TakeProfit==0)tpts=0;
                  
                  
                   
                  
                  
                  int irv=OrderSend(Symbol(),OP_BUYSTOP,lts,oppr,0,aStopLoss,aTakeProfit,aComment,Magic_N,aExpiration,CLR_NONE);
                     if(irv>0){
                        return(irv);
                     }
                     else{
                        Print ("Error set BUYSTOP. "+fMyErDesc(GetLastError())); 
                        return(-1);
                     }
               }
               else{
                  static int lt2=0;
                     if(TimeCurrent()>lt2+20){
                        lt2=TimeCurrent();
                        Print("Need set BUYSTOP. Trade Context Busy");
                     }   
                  return(-2);                 
               }
            }
            else{
               static int lt3=0;
                  if(TimeCurrent()>lt3+20){
                     lt3=TimeCurrent();
                     if(lts==-1)Print("Need set BUYSTOP. No money");
                     if(lts==-2)Print("Need set BUYSTOP. Wrong lots size");                  
                  }  
               return(-3);             
            }
      }
      else{
         static int lt4=0;
            if(TimeCurrent()>lt4+20){
               lt4=TimeCurrent();
               Print("Need set BUYSTOP. Wrong price level ",msl," ",Ask);
            }  
         return(-4);
      }
}

int fOrderSetSellStop(double aOpenPrice,double aStopLoss,double aTakeProfit,datetime aExpiration,string aComment){
   RefreshRates();   
   double oppr=ND(aOpenPrice);
   double msl=ND(Bid-Point*MarketInfo(Symbol(),MODE_STOPLEVEL));
      if(oppr<=msl){
         double lts=fGetLotsSimple(OP_SELL);
            if(lts>0){
               if(!IsTradeContextBusy()){
                  int irv=OrderSend(Symbol(),OP_SELLSTOP,lts,oppr,Slippage,aStopLoss,aTakeProfit,aComment,Magic_N,aExpiration,CLR_NONE);
                     if(irv>0){
                        return(irv);
                     }
                     else{
                        Print ("Error set SELLSTOP. "+fMyErDesc(GetLastError())); 
                        return(-1);
                     }
               }
               else{
                  static int lt2=0;
                     if(TimeCurrent()>lt2+20){
                        lt2=TimeCurrent();
                        Print("Need set SELLSTOP. Trade Context Busy");
                     }   
                  return(-2);                 
               }
            }
            else{
               static int lt3=0;
                  if(TimeCurrent()>lt3+20){
                     lt3=TimeCurrent();
                     if(lts==-1)Print("Need set SELLSTOP. No money");
                     if(lts==-2)Print("Need set SELLSTOP. Wrong lots size");                  
                  }  
               return(-3);             
            }
      }
      else{
         static int lt4=0;
            if(TimeCurrent()>lt4+20){
               lt4=TimeCurrent();
               Print("Need set SELLSTOP. Wrong price level");
            }  
         return(-4);
      }
}

double fLotsNormalize(double aLots){
   aLots-=MarketInfo(Symbol(),MODE_MINLOT);
   aLots/=MarketInfo(Symbol(),MODE_LOTSTEP);
   aLots=NormalizeDouble(aLots,0);
   aLots*=MarketInfo(Symbol(),MODE_LOTSTEP);
   aLots+=MarketInfo(Symbol(),MODE_MINLOT);
   aLots=NormalizeDouble(aLots,2);
   aLots=MathMin(aLots,MarketInfo(Symbol(),MODE_MAXLOT));
   return(aLots);
}

bool fOrderSelectedCommentGetIndex_1(string aDelimiterChar,int & aIndex){
   int FirstS=StringFind(OrderComment(),aDelimiterChar,0);
      if(FirstS==0){
         int SecondS=StringFind(OrderComment(),aDelimiterChar,1);
            if(SecondS>0){
               aIndex=StrToInteger(StringSubstr(OrderComment(),1,SecondS-FirstS-1));
               if(aIndex==0)aIndex=OrderTicket();
               return(true);
            }
      }   
   return(false);
}

int fOrderDeleteStop(bool aDeleteBuyStop=true,bool aDeleteSellStop=true){
   int tErr=0;
      for(int i=OrdersTotal()-1;i>=0;i--){
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
            if(OrderSymbol()==Symbol()){
               if(OrderMagicNumber()==Magic_N){
                  if(OrderType()==OP_BUYSTOP){
                     if(aDeleteBuyStop){
                        RefreshRates();
                           if(!IsTradeContextBusy()){
                              if(!OrderDelete(OrderTicket())){
                                 int tCheck=GetLastError();
                                 Print("Error delete BUYSTOP "+OrderTicket()+" "+fMyErDesc(tCheck)); 
                                 tErr=-1;
                              }
                           }
                           else{
                              static int lt1=0;
                                 if(TimeCurrent()>lt1+20){
                                    lt1=TimeCurrent();
                                    Print("Need delete BUYSTOP "+OrderTicket()+". Trade Context Busy");
                                 }            
                              return(-2);
                           }   
                     }
                  }
                  if(OrderType()==OP_SELLSTOP){
                     if(aDeleteSellStop){
                        RefreshRates();
                           if(!IsTradeContextBusy()){                        
                              if(!OrderDelete(OrderTicket())){
                                 tCheck=GetLastError();
                                 Print("Error delete SELLSTOP "+OrderTicket()+" "+fMyErDesc(tCheck)); 
                                 tErr=-1;
                              }  
                           }
                           else{
                              static int lt2=0;
                                 if(TimeCurrent()>lt2+20){
                                    lt2=TimeCurrent();
                                    Print("Need delete SELLSTOP "+OrderTicket()+". Trade Context Busy");
                                 }            
                              return(-2);
                           }          
                     }
                  }
               }
            }
         }
         else{
            return(-3);
         }
      }
   return(tErr);
} 

bool fOrdersCountMarketAndStop(int & aBuyCount,int & aSellCount,int & aMarketTotal,int & aBuyStopCount,int & aSellStopCount,int & aStopCount,int & aTotal){
   aBuyCount=0;
   aSellCount=0;
   aMarketTotal=0;
   aBuyStopCount=0;
   aSellStopCount=0;
   aStopCount=0;
   aTotal=0;
   
      for(int i=0;i<OrdersTotal();i++){
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
            if(OrderSymbol()==Symbol()){
               if(OrderMagicNumber()==Magic_N){
                  switch (OrderType()){
                     case OP_BUY:
                        aBuyCount++;
                        MarketTicket=OrderTicket();
                        break;
                     case OP_SELL:
                        aSellCount++;
                        MarketTicket=OrderTicket();
                        break;   
                     case OP_BUYSTOP:
                        aBuyStopCount++;
                        break;
                     case OP_SELLSTOP:
                        aSellStopCount++;
                        break;                           
                  }
               }
            }
         }
         else{
            return(false);
         }
      }
   aMarketTotal=aBuyCount+aSellCount;
   aStopCount=aBuyStopCount+aSellStopCount;
   aTotal=aMarketTotal+aStopCount;  
   return(true);
}


void MW_SLTP(){
   double tpts,slts;
      for(int i=0;i<OrdersTotal();i++){
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
            if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic_N){
               RefreshRates();
                  if(OrderType()==OP_BUY || OrderType()==OP_SELL){
                     if(GlobalVariableCheck(gvp+OrderTicket()+"_tp")){
                        if(GlobalVariableCheck(gvp+OrderTicket()+"_sl")){
                           tpts=ND(GlobalVariableGet(gvp+OrderTicket()+"_tp"));
                           slts=ND(GlobalVariableGet(gvp+OrderTicket()+"_sl"));
                              switch(OrderType()){
                                 case OP_BUY:
                                    if(tpts!=0)tpts=MathMax(tpts,ND(Ask+Point*MarketInfo(Symbol(),MODE_STOPLEVEL)));
                                    if(slts!=0)slts=MathMin(slts,ND(Bid-Point*MarketInfo(Symbol(),MODE_STOPLEVEL)));
                                 break;
                                 case OP_SELL:
                                    if(tpts!=0)tpts=MathMin(tpts,ND(Bid-Point*MarketInfo(Symbol(),MODE_STOPLEVEL)));
                                    if(slts!=0)slts=MathMax(slts,ND(Ask+Point*MarketInfo(Symbol(),MODE_STOPLEVEL)));                                 
                                 break;
                              }
                              if(tpts!=ND(OrderTakeProfit()) || slts!=ND(OrderStopLoss())){
                                 if(fModifyOrder(OrderTicket(),OrderOpenPrice(),slts,tpts,OrderExpiration(),"MWMode")==0){
                                    GlobalVariableDel(gvp+OrderTicket()+"_tp");
                                    GlobalVariableDel(gvp+OrderTicket()+"_sl");
                                 }
                              }
                              else{
                                 GlobalVariableDel(gvp+OrderTicket()+"_tp");
                                 GlobalVariableDel(gvp+OrderTicket()+"_sl");
                              }
                        }
                     }
                  }
            }
         }
      }   
}
int fModifyOrder(int aTicket,double aOpenPrice,double aStopLoss,double aTakeProfit,int aExpiration=0,string aCalledFrom=""){
   if(!IsTradeContextBusy()){
         if(!OrderModify(aTicket,ND(aOpenPrice),ND(aStopLoss),ND(aTakeProfit),aExpiration,CLR_NONE)){
            int tCheck=GetLastError();
            Print ("Error modify order "+aTicket+". "+fMyErDesc(tCheck)+" ("+aCalledFrom+")"); 
            return(-1);
         }
      return(0);
   }
   else{
      static int lt1=0;
         if(lt1!=iTime(NULL,0,0)){
            lt1=iTime(NULL,0,0);
            Print("Need modify order "+aTicket+". Trade Context Busy"+" ("+aCalledFrom+")"); 
         }   
      return(-2);   
   }
}


double fGetLotsSimple(int aTradeType){

   // fGetLotsSimple(OP_BUY);
   // fGetLotsSimple(OP_SELL);   

   if(AccountFreeMarginCheck(Symbol(),aTradeType,Lots)<=0){
      return(-1);
   }
   if(GetLastError()==134){
      return(-2);
   }
   return(Lots);  
}


double ND(double v){return(NormalizeDouble(v,Digits));}

int fOrderOpenBuy(string aComment=""){

   // fOrderOpenBuy();

   RefreshRates();
   double lts=fGetLotsSimple(OP_BUY);
      if(lts>0){      
         if(!IsTradeContextBusy()){
            double slts=ND(Ask-Point*StopLoss);
            if(StopLoss==0)slts=0;
            double tpts=ND(Ask+Point*TakeProfit);
            if(TakeProfit==0)tpts=0;
            
               if(StopLossType==2){
                  slts=iCustom(NULL,TimeFrame,IND,SHours,SMinutes,EHours,EMinutes,3,Shift);
                  slts=ND(slts);
                  slts=MathMin(slts,ND(Bid-Point-Point*MarketInfo(Symbol(),MODE_STOPLEVEL)));
               }
               
               if(TakeProfitType==2){
                  if(slts!=0){
                     tpts=ND(Ask+(Ask-slts)*TP_K);
                     tpts=MathMax(tpts,ND(Ask+Point+Point*MarketInfo(Symbol(),MODE_STOPLEVEL)));
                  }
               }               
            
               if(MWMode){
                  double tp2=tpts;
                  double sl2=slts;
                  tpts=0;
                  slts=0;
               }
            int irv=OrderSend(Symbol(),OP_BUY,lts,ND(Ask),Slippage,slts,tpts,aComment,Magic_N,0,CLR_NONE);
               if(irv>0){
                     if(MWMode){
                        GlobalVariableSet(gvp+irv+"_tp",tp2);
                        GlobalVariableSet(gvp+irv+"_sl",sl2);   
                        MW_SLTP();
                     }               
                  LastBuyTime=iTime(NULL,TimeFrame,0);
                  LastSellTime=0;
                  return(irv);
               }
               else{
                  int tCheck=GetLastError();
                  Print ("Error open BUY. "+fMyErDesc(tCheck)); 
                  return(-1);
               }
         }
         else{
            static int lt2=0;
               if(lt2!=iTime(NULL,TimeFrame,0)){
                  lt2=iTime(NULL,TimeFrame,0);
                  Print("Need open buy. Trade Context Busy");
               }            
            return(-2);
         }
      }
      else{
         static int lt3=0;
            if(lt3!=iTime(NULL,TimeFrame,0)){
               lt3=iTime(NULL,TimeFrame,0);
               if(lts==-1)Print("Need open buy. No money");
               if(lts==-2)Print("Need open buy. Wrong lots size");                  
            }
         return(-3);                  
      }
}  


int fOrderOpenSell(string aComment=""){

   // fOrderOpenSell();

   RefreshRates();
   double lts=fGetLotsSimple(OP_SELL);
      if(lts>0){      
         if(!IsTradeContextBusy()){
            double slts;
            slts=ND(Bid+Point*StopLoss);
            if(StopLoss==0)slts=0;               
            double tpts=ND(Bid-Point*TakeProfit);
            if(TakeProfit==0)tpts=0;
            
               if(StopLossType==2){
                  slts=iCustom(NULL,TimeFrame,IND,SHours,SMinutes,EHours,EMinutes,2,Shift);
                  slts=ND(slts+(Ask-Bid));
                  slts=MathMax(slts,ND(Ask+Point+Point*MarketInfo(Symbol(),MODE_STOPLEVEL)));
               }            
            
               if(TakeProfitType==2){
                  if(slts!=0){
                     tpts=ND(Bid-(slts-Bid)*TP_K);
                     tpts=MathMin(tpts,ND(Bid-Point-Point*MarketInfo(Symbol(),MODE_STOPLEVEL)));
                  }
               }              
            
               if(MWMode){
                  double tp2=tpts;
                  double sl2=slts;
                  tpts=0;
                  slts=0;
               }                  
            int irv=OrderSend(Symbol(),OP_SELL,lts,ND(Bid),Slippage,slts,tpts,aComment,Magic_N,0,CLR_NONE);
               if(irv>0){
                     if(MWMode){
                        GlobalVariableSet(gvp+irv+"_tp",tp2);
                        GlobalVariableSet(gvp+irv+"_sl",sl2);   
                        MW_SLTP();
                     }                 
                  LastSellTime=iTime(NULL,TimeFrame,0);
                  LastBuyTime=0;
                  return(irv);
               }
               else{
                  int tCheck=GetLastError();
                  Print ("Error open SELL. "+fMyErDesc(tCheck)); 
                  return(-1);
               }
         }
         else{
            static int lt2=0;
               if(lt2!=iTime(NULL,TimeFrame,0)){
                  lt2=iTime(NULL,TimeFrame,0);
                  Print("Need open sell. Trade Context Busy");
               }            
            return(-2);
         }
      }
      else{
         static int lt3=0;
            if(lt3!=iTime(NULL,TimeFrame,0)){
               lt3=iTime(NULL,TimeFrame,0);
               if(lts==-1)Print("Need open sell. No money");
               if(lts==-2)Print("Need open sell. Wrong lots size");      
            }
         return(-3);                  
      }
}  

string fMyErDesc(int aErrNum){
   
   // fMyErDesc(GetLastError());
   
   string pref="Err Num: "+aErrNum+" - ";
   switch(aErrNum){
      case 0: return(pref+"NO ERROR");
      case 1: return(pref+"NO RESULT");                                 
      case 2: return(pref+"COMMON ERROR");                              
      case 3: return(pref+"INVALID TRADE PARAMETERS");                  
      case 4: return(pref+"SERVER BUSY");                               
      case 5: return(pref+"OLD VERSION");                               
      case 6: return(pref+"NO CONNECTION");                             
      case 7: return(pref+"NOT ENOUGH RIGHTS");                         
      case 8: return(pref+"TOO FREQUENT REQUESTS");                     
      case 9: return(pref+"MALFUNCTIONAL TRADE");                       
      case 64: return(pref+"ACCOUNT DISABLED");                         
      case 65: return(pref+"INVALID ACCOUNT");                          
      case 128: return(pref+"TRADE TIMEOUT");                           
      case 129: return(pref+"INVALID PRICE");                           
      case 130: return(pref+"INVALID STOPS");                           
      case 131: return(pref+"INVALID TRADE VOLUME");                    
      case 132: return(pref+"MARKET CLOSED");                           
      case 133: return(pref+"TRADE DISABLED");                          
      case 134: return(pref+"NOT ENOUGH MONEY");                        
      case 135: return(pref+"PRICE CHANGED");                           
      case 136: return(pref+"OFF QUOTES");                              
      case 137: return(pref+"BROKER BUSY");                             
      case 138: return(pref+"REQUOTE");                                 
      case 139: return(pref+"ORDER LOCKED");                            
      case 140: return(pref+"LONG POSITIONS ONLY ALLOWED");             
      case 141: return(pref+"TOO MANY REQUESTS");                       
      case 145: return(pref+"TRADE MODIFY DENIED");                     
      case 146: return(pref+"TRADE CONTEXT BUSY");                      
      case 147: return(pref+"TRADE EXPIRATION DENIED");                 
      case 148: return(pref+"TRADE TOO MANY ORDERS");                   
      //---- mql4 run time errors
      case 4000: return(pref+"NO MQLERROR");                            
      case 4001: return(pref+"WRONG FUNCTION POINTER");                 
      case 4002: return(pref+"ARRAY INDEX OUT OF RANGE");               
      case 4003: return(pref+"NO MEMORY FOR FUNCTION CALL STACK");      
      case 4004: return(pref+"RECURSIVE STACK OVERFLOW");               
      case 4005: return(pref+"NOT ENOUGH STACK FOR PARAMETER");         
      case 4006: return(pref+"NO MEMORY FOR PARAMETER STRING");         
      case 4007: return(pref+"NO MEMORY FOR TEMP STRING");              
      case 4008: return(pref+"NOT INITIALIZED STRING");                 
      case 4009: return(pref+"NOT INITIALIZED ARRAYSTRING");            
      case 4010: return(pref+"NO MEMORY FOR ARRAYSTRING");              
      case 4011: return(pref+"TOO LONG STRING");                        
      case 4012: return(pref+"REMAINDER FROM ZERO DIVIDE");             
      case 4013: return(pref+"ZERO DIVIDE");                            
      case 4014: return(pref+"UNKNOWN COMMAND");                        
      case 4015: return(pref+"WRONG JUMP");                             
      case 4016: return(pref+"NOT INITIALIZED ARRAY");                  
      case 4017: return(pref+"DLL CALLS NOT ALLOWED");                  
      case 4018: return(pref+"CANNOT LOAD LIBRARY");                    
      case 4019: return(pref+"CANNOT CALL FUNCTION");                   
      case 4020: return(pref+"EXTERNAL EXPERT CALLS NOT ALLOWED");      
      case 4021: return(pref+"NOT ENOUGH MEMORY FOR RETURNED STRING");  
      case 4022: return(pref+"SYSTEM BUSY");                            
      case 4050: return(pref+"INVALID FUNCTION PARAMETERS COUNT");      
      case 4051: return(pref+"INVALID FUNCTION PARAMETER VALUE");       
      case 4052: return(pref+"STRING FUNCTION INTERNAL ERROR");         
      case 4053: return(pref+"SOME ARRAY ERROR");                       
      case 4054: return(pref+"INCORRECT SERIES ARRAY USING");           
      case 4055: return(pref+"CUSTOM INDICATOR ERROR");                 
      case 4056: return(pref+"INCOMPATIBLE ARRAYS");                    
      case 4057: return(pref+"GLOBAL VARIABLES PROCESSING ERROR");      
      case 4058: return(pref+"GLOBAL VARIABLE NOT FOUND");              
      case 4059: return(pref+"FUNCTION NOT ALLOWED IN TESTING MODE");   
      case 4060: return(pref+"FUNCTION NOT CONFIRMED");                 
      case 4061: return(pref+"SEND MAIL ERROR");                        
      case 4062: return(pref+"STRING PARAMETER EXPECTED");              
      case 4063: return(pref+"INTEGER PARAMETER EXPECTED");             
      case 4064: return(pref+"DOUBLE PARAMETER EXPECTED");              
      case 4065: return(pref+"ARRAY AS PARAMETER EXPECTED");            
      case 4066: return(pref+"HISTORY WILL UPDATED");                   
      case 4067: return(pref+"TRADE ERROR");                            
      case 4099: return(pref+"END OF FILE");                            
      case 4100: return(pref+"SOME FILE ERROR");                        
      case 4101: return(pref+"WRONG FILE NAME");                        
      case 4102: return(pref+"TOO MANY OPENED FILES");                  
      case 4103: return(pref+"CANNOT OPEN FILE");                       
      case 4104: return(pref+"INCOMPATIBLE ACCESS TO FILE");            
      case 4105: return(pref+"NO ORDER SELECTED");                      
      case 4106: return(pref+"UNKNOWN SYMBOL");                         
      case 4107: return(pref+"INVALID PRICE PARAM");                    
      case 4108: return(pref+"INVALID TICKET");                         
      case 4109: return(pref+"TRADE NOT ALLOWED");                      
      case 4110: return(pref+"LONGS  NOT ALLOWED");                     
      case 4111: return(pref+"SHORTS NOT ALLOWED");                     
      case 4200: return(pref+"OBJECT ALREADY EXISTS");                  
      case 4201: return(pref+"UNKNOWN OBJECT PROPERTY");                
      case 4202: return(pref+"OBJECT DOES NOT EXIST");                  
      case 4203: return(pref+"UNKNOWN OBJECT TYPE");                    
      case 4204: return(pref+"NO OBJECT NAME");                         
      case 4205: return(pref+"OBJECT COORDINATES ERROR");               
      case 4206: return(pref+"NO SPECIFIED SUBWINDOW");                 
      case 4207: return(pref+"SOME OBJECT ERROR");    
      default: return(pref+"WRONG ERR NUM");                
   }
}  


bool fDataUpdate(string aSymbol,int aTimeFrame,int aMinBars=300){
   datetime daytimes[];
      if(iClose(aSymbol,aTimeFrame,0)==0){
         return(false);
      }
   ArrayCopySeries(daytimes,MODE_TIME,aSymbol,aTimeFrame);
      if(GetLastError()==4066){
         return(false);
      }
      if(iBars(aSymbol,aTimeFrame)<aMinBars){
         return(false);
      }
   return(true);      
}

bool fDataUpdateCmnt(string aSymbol,int aTimeFrame,int aMinBars=300){
   static bool tErr=false;
      if(!fDataUpdate(aSymbol,aTimeFrame,aMinBars)){
         tErr=true;
         Comment("   "+aSymbol+" "+fTimeFrameName(aTimeFrame)+"...");
         return(false);          
      }
      if(tErr){
         tErr=false;
         Comment("");
      }
   return(true);
}

string fTimeFrameName(int arg){

   // fTimeFrameName();

   int v;
      if(arg==0){
         v=Period();
      }
      else{
         v=arg;
      }
      switch(v){
         case 0:
            return("0");
         case 1:
            return("M1");
         case 5:
            return("M5");                  
         case 15:
            return("M15");
         case 30:
            return("M30");             
         case 60:
            return("H1");
         case 240:
            return("H4");                  
         case 1440:
            return("D1");
         case 10080:
            return("W1");          
         case 43200:
            return("MN1");
         default:
            return("M"+arg);          
      }
}

