//+------------------------------------------------------------------+
//|                                            iSCH_TimeAndRange.mq4 |
//|                                                                * |
//|                                                                * |
//+------------------------------------------------------------------+
#property copyright "*"
#property link      "*"

#property indicator_chart_window
#property indicator_buffers 4

#property indicator_color1 Aqua
#property indicator_color2 DeepPink

#property indicator_color3 Yellow
#property indicator_color4 Yellow

#property indicator_width1 2
#property indicator_width2 2


//--- input parameters

extern int SHours     =  0; //     
extern int SMinutes   =  0; //    
extern int EHours     =  9; //     
extern int EMinutes   =  0; //    

//--- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double buy[];
double sell[];
double ExtMapBuffer5[];
double f[];
double l[];
double h[];
double ll[];
double hh[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   
   IndicatorBuffers(7);
   
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,159);
   SetIndexBuffer(0,buy);
   SetIndexEmptyValue(0,0.0);
   
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,159);
   SetIndexBuffer(1,sell);
   SetIndexEmptyValue(1,0.0);
   
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,hh);
   
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,ll);

   SetIndexBuffer(4,f);
   SetIndexBuffer(5,l);
   SetIndexBuffer(6,h);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
         int limit=Bars-IndicatorCounted()-1;

            for(int i=limit;i>=0;i--){
            
               buy[i]=0;
               sell[i]=0;
            
               h[i]=h[i+1];
               l[i]=l[i+1];
               
               f[i]=f[i+1];
               
               hh[i]=hh[i+1];
               ll[i]=ll[i+1];
               
               if(fTimeCross(EHours,EMinutes,Time[i],Time[i+1])){
                  hh[i]=h[i];
                  ll[i]=l[i];
                  f[i]=2;
               }
               
               if(fTimeCross(SHours,SMinutes,Time[i],Time[i+1])){
                  h[i]=High[i];
                  l[i]=Low[i];
                  f[i]=1;
               }
               if(f[i]==1){
                  h[i]=MathMax(h[i],High[i]);
                  l[i]=MathMin(l[i],Low[i]);
               }
               
               if(f[i]==2){
                  if(High[i]>h[i]){
                     buy[i]=h[i];
                     f[i]=0;
                  }
                  if(Low[i]<l[i]){
                     sell[i]=l[i];
                     f[i]=0;
                  }
                  
               }
               

            }
   return(0);
  }
//+------------------------------------------------------------------+

bool fTimeCross(int aPointHour,int aPointMinute,datetime aCurTime,datetime aPreTime){
   datetime tPointTime=aPointHour*3600+aPointMinute*60;
   aCurTime%=86400;
   aPreTime%=86400;
      if(aCurTime>aPreTime){
         if(aPreTime<tPointTime){
            if(aCurTime>=tPointTime){
               return(true);
            }
         }
      }
      else{
         if(aCurTime<aPreTime){
            if(aCurTime>=tPointTime || aPreTime<tPointTime){
               return(true);
            }      
         }
      }
   return(false);      
}

